%global install_loc			%{_datadir}/eclipse/dropins/wtp-sourceediting

%global	sourceediting_tag	201305161752
%global	sourceediting_dir	webtools.sourceediting-%{sourceediting_tag}

%global	xsl_tag				201304241031
%global	xsl_dir				webtools.sourceediting.xsl-%{xsl_tag}

%global	xpath_tag			201302282018
%global	xpath_dir			webtools.sourceediting.xpath-%{xpath_tag}

%global	tests_tag			201304111437
%global	tests_dir			webtools.sourceediting.tests-%{tests_tag}

%global	jsdt_core_tag		201301022000
%global	jsdt_core_dir		webtools.jsdt.core-%{jsdt_core_tag}

%global	jsdt_debug_tag		201209252144
%global	jsdt_debug_dir		webtools.jsdt.debug-%{jsdt_debug_tag}

%global	javaee_tag			201305152300
%global	javaee_dir			webtools.javaee-%{javaee_tag}

Name:			eclipse-wtp-sourceediting
Version:		3.5.0
Release:		0.1%{?dist}
Summary:		WTP Source Editing

Group:			Development/Tools
License:		EPL
URL:			http://www.eclipse.org/projects/project.php?id=webtools.sourceediting

Source0:		http://git.eclipse.org/c/sourceediting/webtools.sourceediting.git/snapshot/%{sourceediting_dir}.tar.bz2
Source1:		http://git.eclipse.org/c/sourceediting/webtools.sourceediting.xsl.git/snapshot/%{xsl_dir}.tar.bz2
Source2:		http://git.eclipse.org/c/sourceediting/webtools.sourceediting.xpath.git/snapshot/%{xpath_dir}.tar.bz2
Source4:		http://git.eclipse.org/c/jsdt/webtools.jsdt.core.git/snapshot/%{jsdt_core_dir}.tar.bz2
Source5:		http://git.eclipse.org/c/jsdt/webtools.jsdt.debug.git/snapshot/%{jsdt_debug_dir}.tar.bz2
Source6:		http://git.eclipse.org/c/jeetools/webtools.javaee.git/snapshot/%{javaee_dir}.tar.bz2

BuildArch:		noarch

Patch1:			xml-core-feature.patch
Patch2:			xml-core.patch
Patch4:			%{name}-wst.xsl-rm-commons.logging-version-check.patch
Patch5:			%{name}-rhino-debugger-update.patch

BuildRequires: java-devel
BuildRequires: jpackage-utils

BuildRequires: eclipse-platform >= 4.3.0
BuildRequires: eclipse-pde >= 4.3.0
BuildRequires: eclipse-emf >= 2.9.0
BuildRequires: eclipse-emf-xsd >= 2.9.0
BuildRequires: eclipse-emf-core >= 2.9.0
BuildRequires: eclipse-gef >= 3.9.0
BuildRequires: eclipse-wtp-common >= 3.5.0
BuildRequires: eclipse-wtp-servertools >= 3.5.0
BuildRequires: eclipse-rcp >= 4.3.0
BuildRequires: eclipse-swt >= 4.3.0
BuildRequires: eclipse-jdt >= 4.3.0
BuildRequires: icu4j-eclipse >= 1:4.4.2.2

BuildRequires: ant >= 1.8.3
BuildRequires: xerces-j2 >= 2.11.0
BuildRequires: xalan-j2 >= 2.7.1-10
BuildRequires: xml-commons-apis >= 1.3.4
BuildRequires: xml-commons-resolver >= 1.2
BuildRequires: rhino >= 1.7R4
BuildRequires: java_cup >= 1:0.11a-8
BuildRequires: bcel >= 5.1-11
BuildRequires: glassfish-jsp-api >= 2.2.1
BuildRequires: apache-commons-logging >= 1.1.1
BuildRequires: log4j >= 1.2.17-2

Requires: java
Requires: jpackage-utils

Requires: eclipse-platform >= 4.3.0
Requires: eclipse-emf >= 2.9.0
Requires: eclipse-emf-xsd >= 2.9.0
Requires: eclipse-emf-core >= 2.9.0
Requires: eclipse-gef >= 3.9.0
Requires: eclipse-wtp-common >= 3.5.0
Requires: eclipse-wtp-servertools >= 3.5.0
Requires: eclipse-rcp >= 4.3.0
Requires: eclipse-swt >= 4.3.0
Requires: eclipse-jdt >= 4.3.0
Requires: icu4j-eclipse >= 1:4.4.2.2

Requires: ant >= 1.8.3
Requires: xerces-j2 >= 2.11.0
Requires: xalan-j2 >= 2.7.1-10
Requires: xml-commons-apis >= 1.3.4
Requires: xml-commons-resolver >= 1.2
Requires: rhino >= 1.7R4
Requires: java_cup >= 1:0.11a-8
Requires: bcel >= 5.1-11
Requires: glassfish-jsp-api >= 2.2.1
Requires: log4j >= 1.2.17-2


%description
WTP Source editing tools provide support for editing typical "web" languages
and the mixing of them. XML, XML Schema, XSL, HTML, CSS, DTD, and JSP   
resources, as well as an XML Perspective.

%prep
%setup -q -c
%setup -q -T -D -a 1
%setup -q -T -D -a 2
%setup -q -T -D -a 4
%setup -q -T -D -a 5
%setup -q -T -D -a 6

#Orbit links
rm -rf orbit
mkdir orbit
pushd orbit
%{__ln_s} %{_javadir}/xalan-j2-serializer.jar
%{__ln_s} %{_javadir}/xalan-j2.jar
%{__ln_s} %{_javadir}/xerces-j2.jar
%{__ln_s} %{_javadir}/xml-commons-apis.jar
%{__ln_s} %{_javadir}/xml-resolver.jar
%{__ln_s} %{_javadir}/rhino.jar
%{__ln_s} %{_javadir}/apache-commons-discovery.jar
%{__ln_s} %{_javadir}/apache-commons-logging.jar
%{__ln_s} %{_javadir}/bcel.jar
%{__ln_s} %{_javadir}/java_cup-runtime.jar
%{__ln_s} %{_javadir}/log4j.jar
popd

#Patch XML_CORE feature.xml xerces version
pushd %{sourceediting_dir}/features/
%patch1
popd

#Patch XML_CORE XMLValidator.java for Xerces new version
pushd %{sourceediting_dir}/bundles/
%patch2
popd

#Remove old version check for org.apache.commons.logging
pushd %{xsl_dir}/features/
%patch4
popd

# Update for rhino 1.7R4 - patch from eclipse bugzilla
# https://bugs.eclipse.org/bugs/show_bug.cgi?id=387850
pushd %{jsdt_debug_dir}/
%patch5 -p1
popd

#Remove license attributes from feature.xml
find -name feature.xml -exec sed -i -e 's/license-feature.*"//' '{}' \;

%build
OPTIONS="-DforceContextQualifier=201109301723 -DjavacSource=1.5 -DjavacTarget=1.5"

eclipse-pdebuild -f org.eclipse.wst.web_ui.feature \
	-d "xsd emf gef eclipse-wtp-common org.eclipse.wst.server_ui.feature" \
	-o `pwd`/orbit -a "${OPTIONS}"

eclipse-pdebuild -f org.eclipse.wst.xsl.feature \
	-d "xsd emf gef eclipse-wtp-common" \
	-o `pwd`/orbit -a "${OPTIONS}"


%install
install -d -m 755 %{buildroot}%{install_loc}

%{__unzip} -q -d %{buildroot}%{install_loc} \
     build/rpmBuild/org.eclipse.wst.web_ui.feature.zip
%{__unzip} -q -o -d %{buildroot}%{install_loc} \
     build/rpmBuild/org.eclipse.wst.xsl.feature.zip

#Recreate symlinks & remove duplicate jars
pushd %{buildroot}%{install_loc}/eclipse/plugins
rm -f org.apache.xml.serializer*.jar
rm -f org.apache.xerces*.jar
rm -f javax.xml*.jar
rm -f org.apache.xml.resolver*.jar
rm -f org.mozilla.javascript*.jar
rm -f java_cup.runtime_*.jar
rm -f org.apache.bcel_*.jar
rm -f org.apache.commons.logging_*.jar
rm -f org.apache.xalan_*.jar
rm -f org.apache.log4j_*.jar

#Remove duplicates because of improper including
rm -f org.eclipse.jem.util*.jar
rm -f org.eclipse.wst.common.*.jar
rm -f org.eclipse.wst.internet.cache_*.jar
rm -f org.eclipse.wst.validation_*.jar
rm -f org.eclipse.wst.validation.infopop_*.jar
rm -f org.eclipse.wst.validation.ui_*.jar

%{__ln_s} %{_javadir}/xalan-j2-serializer.jar
%{__ln_s} %{_javadir}/xerces-j2.jar
%{__ln_s} %{_javadir}/xml-commons-apis.jar
%{__ln_s} %{_javadir}/xml-resolver.jar
%{__ln_s} %{_javadir}/rhino.jar
%{__ln_s} %{_javadir}/java_cup-runtime.jar
%{__ln_s} %{_javadir}/bcel.jar
%{__ln_s} %{_javadir}/apache-commons-logging.jar
%{__ln_s} %{_javadir}/xalan-j2.jar
%{__ln_s} %{_javadir}/log4j.jar

popd

%files
%{install_loc}
%doc %{sourceediting_dir}/docs/org.eclipse.wst.doc.user/about.html

%changelog
* Thu May 23 2013 Gerard Ryan <galileo@fedoraproject.org> 3.5.0-0.1
- Start building from upstream master branches in anticipation for 3.5.0

* Mon Apr 22 2013 Gerard Ryan <galileo@fedoraproject.org> 3.4.2-2
- RHBZ #842588 - compile with -target 1.5 or greater

* Sun Apr 21 2013 Gerard Ryan <galileo@fedoraproject.org> 3.4.2-1
- Update to upstream 3.4.2
- Update minimum BR/R dependency versions
- Remove unnecessary patch

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jul 12 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.4.0-1
- Update to latest upstream.

* Sun Jun 24 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.2.M6
- Include org.eclipse.wst.xsl.feature.

* Fri Apr 27 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.4.0-0.1.M6
- Update to latest upstream revision (3.4.0 post M6)

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.3.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sun Oct 16 2011 Vladimir Kostadinov <vladimir.kostadinov@gmail.com> 3.3.1-1
- Update to upstream 3.3.1 

* Mon Sep 19 2011 Vladimir Kostadinov <vladimir.kostadinov@gmail.com> 3.3.0-3
- Fixed description length
- Fixed doc file permissions in fetch-wtp-sourceediting.sh

* Thu Sep 15 2011 Vladimir Kostadinov <vladimir.kostadinov@gmail.com> 3.3.0-2
- Fixed PDE Build Eclipse plugin dependencies

* Tue Sep 13 2011 Vladimir Kostadinov <vladimir.kostadinov@gmail.com> 3.3.0-1
- Initial Fedora package
